use categorized_hand::CategorizedHand;

mod categorized_hand;
mod dealt_hand;
mod hand_kind;
mod parsing;

/// TODO: wrong answer for 253639210 is too low for my puzzle input
pub fn solve_task_1(input: &str) -> String {
    let parsed = parsing::parse_input(input);
    let sorted_and_categorized = {
        let mut categorized: Vec<_> = parsed.into_iter().map(CategorizedHand::from).collect();
        categorized.sort();
        categorized
    };
    let total_score = calc_bid_and_ranks(&sorted_and_categorized);
    total_score.to_string()
}

fn calc_bid_and_ranks(sorted: &[CategorizedHand]) -> usize {
    sorted
        .into_iter()
        .enumerate()
        .map(|(index, hand)| {
            let rank = index + 1;
            hand.score() * rank
        })
        .sum()
}

#[cfg(test)]
const TEST_INPUT: &str = "32T3K 765
T55J5 684
KK677 28
KTJJT 220
QQQJA 483
";

#[cfg(test)]
mod testing {
    use super::TEST_INPUT;

    #[test]
    fn solve_example_according_to_task_1() {
        let actual = super::solve_task_1(TEST_INPUT);
        let expected = "6440";
        assert_eq!(expected, actual);
    }
}
